#ifndef _QJVoiceWidget_H
#define _QJVoiceWidget_H


#include <qwidget.h>
#include "base/JOSTemplate.h"
#include "rep/JVoiceUpdate.h"

class JMidiIn;
class JMidiMap;
class QJSlider;
class QPushButton;
class QJChannelWidget;
class JVoice;
class QJMapperWidget;
class JContext;
class JFocus;

class QJVoiceWidget:public QWidget,
		    public JObserver<const JFocus *,void>

{

  Q_OBJECT
public:
  QJVoiceWidget(JContext *context,
		QWidget *parent=0, const char *name=0 );
  ~QJVoiceWidget();

  void handle(const JFocus *);
  const char *name() const { return QWidget::name(); }
public  slots:
  void resetVoice();
  void myQuit();

protected:

  QJChannelWidget *  _channelWgt;
  QJMapperWidget  *  _mapperWgt;
  JContext  *        _context;
  JVoice *           _voice;
};

#endif




